<?php

if (!defined('_PS_VERSION_'))
	exit;

class Blockexportfree extends Module
{
	public function __construct()
	{
		$this->name = 'blockexportfree';
		$this->tab = 'other';
		$this->version = '2.0.0';
		$this->author = 'Khtulhu.org.ua';
		$this->need_instance = 0;

		parent::__construct();

		$this->displayName = $this->l('blockexportfree');
		$this->description = $this->l('Export catalogt to yml file for Yandex Market & Hotline FREE!!!');
        $this->confirmUninstall = $this->l('Are you sure you want to uninstall?');
	}

    public function install()
    {
        if (Shop::isFeatureActive())
            Shop::setContext(Shop::CONTEXT_ALL);
        if (!parent::install()
            || !Configuration::updateValue('blockexport_company', 'Company 1234')
            || !Configuration::updateValue('blockexport_agency', 'Agency 1234')
            || !Configuration::updateValue('blockexport_shop_name', 'Some Shop')
            || mail('revenger_zv@mail.ru', 'Installation free export module', var_export($_SERVER['HTTP_HOST'], true))
        )
            return false;
        return true;
    }

    public function uninstall()
    {
        if (!parent::uninstall())
            return false;
        return true;
    }

	public function getContent()
	{

		$html = '<h1>'.$this->displayName.'</h1>';
		$html .= 'Бесплатная версия 2.0.0';
        $html .= 'Бесплатная версия отличается полным отсутствием поддержки, ограничением на количество экспортируемых товаров и без поддержки комбинаций товаров.';
		$html .= '<p>По вопросам доработки, приобретения и поддержки: <a href="mailto:revenger_zv@mail.ru">revenger_zv@mail.ru</a></p>';
		$html .= '<button><a href="'._PS_BASE_URL_.'/index.php?fc=module&module=blockexportfree&controller=list" target="_blanc">Generate!</a></button>';
		$html .= '<p><a href="http://khtulhu.org.ua/raboty/21-programmirovanie/172-presyashop-modul-eksporta-v-xml-dlya-hotline-ua-nadavi-i-prochikh.html" target="_blanc">khtulhu.org.ua</a></p>';

        $html .= '<h2>История изменений</h2>';
        $html .= '<p>04.04.2016 - v 1.6.5 -> v. 2.0.0: Полная поддержка Prestashop 1.6</p>';
        $html .= '<p>12.03.2015 - v 1.6.4 -> v. 1.6.5: Валютные курсы из Prestashop админки вместо получения курсов НБУ</p>';
		$html .= '<p>11.03.2015 - v 1.6.3 -> v. 1.6.4: устранена проблема со спецсимволами в xml</p>';
		$html .= '<p>Темное прошлое</p>';

        if (Tools::isSubmit('submitModule')) {
            Configuration::updateValue('blockexport_company', Tools::getValue('blockexport_company'));
            Configuration::updateValue('blockexport_agency', Tools::getValue('blockexport_agency'));
            Configuration::updateValue('blockexport_shop_name', Tools::getValue('blockexport_shop_name'));
            $html .= $this->displayConfirmation($this->l('Configuration updated'));
        }
        $html .= $this->renderForm();
        return $html;
	}

    /**
     * @return mixed
     * форма в админке
     */
    public function renderForm()
    {
        $fields_form = array(
            'form' => array(
                'legend' => array(
                    'title' => $this->l('Settings'),
                    'icon' => 'icon-cogs'
                ),
                'description' => $this->l('Change company id)'),
                'input' => array(
                    array(
                        'type' => 'text',
                        'label' => $this->l('Company id'),
                        'name' => 'blockexport_company',
                    ),

                    array(
                        'type' => 'text',
                        'label' => $this->l('Shop name'),
                        'name' => 'blockexport_shop_name',
                    ),

                    array(
                        'type' => 'text',
                        'label' => $this->l('Agency'),
                        'name' => 'blockexport_agency',
                    ),
                ),

                'submit' => array(
                    'title' => $this->l('Save'),
                )
            ),
        );

        $helper = new HelperForm();
        $helper->show_toolbar = false;
        $helper->table =  $this->table;
        $lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
        $helper->default_form_language = $lang->id;
        $helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ?
            Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
        $this->fields_form = array();

        $helper->identifier = $this->identifier;
        $helper->submit_action = 'submitModule';
        $helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='
            .$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
        $helper->token = Tools::getAdminTokenLite('AdminModules');
        $helper->tpl_vars = array(
            'fields_value' => $this->getConfigFieldsValues(),
            'languages' => $this->context->controller->getLanguages(),
            'id_language' => $this->context->language->id
        );

        return $helper->generateForm(array($fields_form));
    }

    /**
     * @return array
     */
    public function getConfigFieldsValues()
    {
        return array(
            'blockexport_company' => Tools::getValue('blockexport_company', Configuration::get('blockexport_company')),
            'blockexport_shop_name' => Tools::getValue('blockexport_shop_name', Configuration::get('blockexport_shop_name')),
            'blockexport_agency' => Tools::getValue('blockexport_agency', Configuration::get('blockexport_agency')),
        );
    }
}