<?php
/**
 * 2007-2016 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future.If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 * @author    Revenger <revenger_zv@mail.ru>
 * @copyright 2007-2016 Revenger
 * @license   http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 * International Registered Trademark & Property of PrestaShop SA
 */

class BlockexportfreeListModuleFrontController extends ModuleFrontController
{

    public function initContent()
    {

        parent::initContent();
        $id_lang = Configuration::get('PS_LANG_DEFAULT');
        ### VARIABLES  ###
        $shop_name = Configuration::get('blockexport_shop_name');
        $company = Configuration::get('blockexport_company');
        $url = _PS_BASE_URL_;
        $platform = 'Prestashop';
        $version = '1.6';
        $agency = Configuration::get('blockexport_agency');
        $email = Configuration::get('PS_SHOP_EMAIL');
        $currencies = $this->currencyList();
        $categories = $this->getCategoriesList($id_lang);

        $offers = $this->productList($id_lang); // no combs

        /*
        * working export products
        */

        $export_active = 0;
        $export_category = 2; // id категории. Можно указать главную категорию
        $order_by = 'id_product';
        $order_way = 'ASC';



        ######################
        ### START YML FILE ###
        ######################

        $html = '';

        $html .= '<?xml version="1.0" encoding="windows-1251"?>';
        $html .= "\n";
        $html .= '<yml_catalog date="'.date("Y-m-d h:i").'">';
        $html .= "\n";
        $html .= '    <shop>
        <name>'.$shop_name.'</name>
        <company>'.$company.'</company>
        <url>'.$url.'</url>
        <platform>'.$platform.'</platform>
        <version>'.$version.'</version>
        <agency>'.$agency.'</agency>
        <email>'.$email.'</email>
        <currencies>'.$currencies.'</currencies>
        '.$categories.'
        <delivery-options> ... </delivery-options>
        <cpa>0</cpa>
        '.$offers.'
    </shop>';
        $html .= "\n";
        $html .= '</yml_catalog>';

        $fh = fopen('php://output', 'w');
        ob_start();

        echo $html;

        $string = ob_get_clean();
        $filename = 'price_' . date('Ymd') .'-' . date('His');
        header('Pragma: public');
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Cache-Control: private', false);
        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename="' . $filename . '.xml";');
        header('Content-Transfer-Encoding: binary');
        exit($string);
    }

    /**
     * @param $id_lang
     * @throws PrestaShopDatabaseException
     * выводит список категорий
     */
    public function getCategoriesList($id_lang) {
        $query = "SELECT";
        $query .= " ";
        $query .= "a.id_category AS aidcat";
        $query .= ", ";
        $query .= "a.id_parent AS parent";
        $query .= ", ";
        $query .= "b.id_shop AS shop";
        $query .= ", ";
        $query .= "a.active AS act";
        $query .= ", ";
        $query .= "b.id_category AS bidcat";
        $query .= ", ";
        $query .= "b.name AS bname";
        $query .= ", ";
        $query .= "b.id_lang AS lng";
        $query .= " ";
        $query .= "FROM";
        $query .= " ";
        $query .= _DB_PREFIX_."category AS a";
        $query .= " ";
        $query .= "LEFT JOIN";
        $query .= " ";
        $query .= _DB_PREFIX_."category_lang AS b";
        $query .= " ";
        $query .= "on (a.id_category=b.id_category)";
        $query .= " ";
        $query .= "WHERE";
        $query .= " ";
        $query .= "a.active = 1";
        $query .= " ";
        $query .= "AND";
        $query .= " ";
        $query .= "b.id_lang = ".$id_lang;
        $query .= " ";
        $query .= "AND";
        $query .= " ";
        $query .= "b.id_shop = 1";
        $res = Db::getInstance()->ExecuteS($query);

        $xml_cats = '';
        $xml_cats .= '<categories>';
        $xml_cats .= "\n";
        foreach ($res as $row) {
            if ($row['aidcat'] > 2) {
                $parent_category = '';
                if($row['parent'] > 2) {
                    $parent_category = ' parentId="'.$row['parent'].'"';
                }
                $xml_cats .= '          <category id="'.$row['bidcat'].'"'.$parent_category.'>'.$row['bname'].'</category>';
                $xml_cats .= "\n";
            }
        }
        $xml_cats .= '</categories>';
        return $xml_cats;
    }

    /**
     * @return array
     * @throws PrestaShopDatabaseException
     * список используемых валют магазина
     */
    public function currencyList()
    {
        $query = "SELECT iso_code, iso_code_num, conversion_rate FROM "._DB_PREFIX_."currency";
        $row = Db::getInstance()->ExecuteS($query);
        $html = "\n";
        foreach ($row as $currency) {
            $html .= '          <currency id="'.$currency["iso_code"].'" rate="'.$currency["conversion_rate"].'"/>';
            $html .= "\n";
        }
        return $html;
    }

    // а в бесплатной версии юзай без комбинаций
    public function productList($id_lang)
    {
        $export_active = 0;
        $export_category = 2; // id категории. Можно указать главную категорию
        $order_by = 'id_product';
        $order_way = 'ASC';

        $products = Product::getProducts($id_lang, 0, 0, $order_by, $order_way, $export_category, $export_active);

        $html = '';
        $html .= '<offers>';
        $html .= "\n";
        foreach ($products as $product) {
            $html .= '            <offer id="'.$product['id_product'].'" type="vendor.model" available="false">'."\n";
            $html .= '                <url></url>'."\n";
            $html .= '                <picture>'.$this->getImageUrlByProductId($product['id_product']).'</picture>'."\n";
            $html .= "                <price>".$product['price']."</price>"."\n";
#            $html .= "<oldprice>800</oldprice>"; // добавить пересчет с учетом скидок
            $html .= "                <currencyId>".$this->context->currency->iso_code."</currencyId>"."\n";
            $html .= "                <categoryId>".$product['id_category_default']."</categoryId>"."\n";
            $html .= "                <store>false</store>"."\n";
            $html .= "                <pickup>true</pickup>"."\n";
            $html .= "                <delivery>true</delivery>"."\n";
            $html .= "                <vendor>".$product['manufacturer_name']."</vendor>"."\n";
            $html .= "                <model>".$product['name']."</model>"."\n";
            $html .= "                <description>".$product['description']."</description>"."\n";
            $html .= "                <manufacturer_warranty>true</manufacturer_warranty>"."\n";
            $html .= "                <country_of_origin>".$this->manufacturerInfo($product['id_manufacturer'])."</country_of_origin>"."\n";
            $html .= "                <cpa>1</cpa>"."\n"; // 0 — товар/YML-файл не участвует в программе «Заказ на Маркете»;
            $html .= "            </offer>";
            $html .= "\n";
        }
        $html .= '        </offers>';

        return $html;
    }

    /**
     * @param $id
     * @return string
     * returns image url
     */
    public function getImageUrlByProductId($id)
    {
        if(!empty($id)) {
            $id_image = Product::getCover($id);
            if (sizeof($id_image) > 0) {
                $image = new Image($id_image['id_image']);
                // get image full URL
                $image_url = _PS_BASE_URL_ . _THEME_PROD_DIR_ . $image->getExistingImgPath() . ".jpg";
                return $image_url;
            }
        } else {
            return _PS_BASE_URL_.'/modules/blockexport/views/img/dummy-image.jpg';
        }
    }

    /**
     * @param $id
     * @return mixed
     * returns info like origin country
     */
    public function manufacturerInfo($id)
    {
        if(!empty($id)) {
            $manufacturer = new Manufacturer($id, $this->context->language->id);
            $addresses = $manufacturer->getAddresses($this->context->language->id);
            return $addresses[0]['country'];
        }
    }

    public function productAttributes($product_id, $id_lang)
    {
        $product = new Product($product_id);
        $atributes = $product->getAttributeCombinaisons($id_lang);

        // получить уникальные id атрибутов
        foreach ($atributes as $k => $attribute) {
            // получить индекс
            $index_attr[] = $attribute['id_product_attribute'];
        }

        $index_attr = array_unique($index_attr);

        foreach ($index_attr as $attr_id) {
            $current_product_attributes[] = array(
                'id'            => $product_id,
                'attributes'    => $this->subAction($attr_id, $product_id),
            );
        }
        if (is_array($current_product_attributes)
        && !empty($current_product_attributes)) {
            return $current_product_attributes;
        } else {
            return false;
        }
    }

    /**
     * @param $attribute_id
     * возвращает id_product_attribute с id
     * из $index_attr
     * На выходе должны быть все атрибуты одной комбинации
     */
    public function subAction($attribute_id, $product_id)
    {
        $product = new Product($product_id);
        $atributes = $product->getAttributeCombinaisons($this->context->language->id);

        foreach ($atributes as $k => $attribute) {

            if ($attribute['id_product_attribute'] == $attribute_id) {
                $attrs[] = array(
                    'name'          => $attribute["group_name"],
                    'value'         => $attribute["attribute_name"],
                );
            }
        }
        if (is_array($attrs)
        && !empty($attrs)) {
            return $attrs;
        } else {
            return false;
        }
    }
}
